Bug 1004565 - Review Request: eureka - A cross-platform map editor for the classic DOOM games
Review Request: eureka - A cross-platform map editor for the classic DOOM games
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Christopher Meng
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-04 20:24 EDT by Jay Greguske
Modified: 2014-02-24 07:28 EST (History)
2 users (show)

See Also:
Fixed In Version: eureka-1.00-3.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-24 07:27:50 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
i: fedora‑review+
petersen: fedora‑cvs+


Attachments (Terms of Use)
changes to spec to address issues from comment #7 (1.43 KB, patch)
2013-09-06 00:36 EDT, Ralf Corsepius
no flags Details | Diff

  None (edit)
Description Jay Greguske 2013-09-04 20:24:40 EDT
spec/SRPM URL: http://jgreguske.fedorapeople.org/eureka/

Description:
Eureka is a cross-platform map editor for the classic DOOM games. The supported
operating systems are Linux (and other Unix-likes), Windows and MacOS X.

It started when the ported the Yadex editor to a proper GUI toolkit, namely
FLTK, and implemented a system for multi-level Undo / Redo. These and other
features have required rewriting large potions of the existing code, and adding
lots of new code too. Eureka is now an independent program with its own
work-flow and its own quirks.


Fedora Account System Username: jgreguske
Comment 1 Christopher Meng 2013-09-04 20:26:42 EDT
You'd better add spec and srpm link in the comment so we can run

fedora-review -b 1004565

quickly.

FIrst question before review, are you going to support EL?(I think no need for this pacakge)
Comment 2 Jay Greguske 2013-09-05 07:40:50 EDT
Here are some direct links:

http://jgreguske.fedorapeople.org/eureka/eureka-1.00-1.fc19.src.rpm
http://jgreguske.fedorapeople.org/eureka/eureka.spec

No plans for EPEL.
Comment 3 Christopher Meng 2013-09-05 09:08:08 EDT
OK.

Remove:

BuildRoot:  %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

rm -rf %{buildroot} in %install

Whole %clean section

%defattr(-,root,root,-)

And it's nonsense to ship INSTALL.txt as %doc.

========

Have you notified upstream about this?

%{__sed} -i "s|INSTALL_PREFIX=/usr/local|INSTALL_PREFIX=%{buildroot}%{_prefix}|" Makefile

And, you should use sed but not %{__sed}, also %{__mkdir_p} but not mkdir -p

========

%{_datadir}/%{name}/*

You forgot to own %{_datadir}/%{name} itself.

========

%description is not good:

Eureka is a cross-platform map editor for the classic DOOM games. The supported
operating systems are Linux (and other Unix-likes), Windows and MacOS X.

I think we don't need to mention "(and other Unix-likes), Windows and MacOS X."


========

Explicit requires:

Requires:       expat
Requires:       fltk
Requires:       fontconfig
Requires:       freetype
Requires:       libjpeg
Requires:       libpng
Requires:       libX11
Requires:       libXau
Requires:       libXcursor
Requires:       libXext
Requires:       libXfixes
Requires:       libXft
Requires:       libxcb
Requires:       libXinerama
Requires:       libXrender
Requires:       mesa-libGLU
Requires:       zlib

You should remove most of them, however I will run fedora-review later to find if some of them should be kept or not.

========

Why did you disable debuginfo?

%global debug_package %{nil}???
Comment 4 Jay Greguske 2013-09-05 11:28:35 EDT
I can get this tonight, so here's a few answers for you now:

- Why do you recommend against the sed and mkdir macros?
- I did recommend upstream support DESTDIR or PREFIX in the Makefile, and they were open to adding it. There may even be a Makefile.fedora for our use case, but in any event it is not included in the current release. I will package it up in an update.
- The debuginfo package was always 0 length. I'm not really sure why, (maybe no -g?) but it seemed pointless to include it.
Comment 5 Michael Schwendt 2013-09-05 13:49:36 EDT
> The debuginfo package was always 0 length. I'm not really sure why,
> (maybe no -g?)

https://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags

Or something in the Makefile strips the built files.


> but it seemed pointless to include it.

That's an odd conclusion. Better fix the package, so that a fine -debuginfo package will be generated.


> %build
> make %{?_smp_mflags}

Well, there's nothing that enables Fedora's compiler flags. If there's no Makefile variable you could preset when running "make", you may need to patch the Makefile.

If the Makefile inherits CFLAGS and CXXFLAGS, some packagers do:

  [ -f configure ] && exit -1
  echo '#!/bin/sh' > configure
  %configure
  make %{?_smp_mflags}
Comment 6 Christopher Meng 2013-09-06 00:12:31 EDT
(In reply to Jay Greguske from comment #4)
> I can get this tonight, so here's a few answers for you now:

Ok, please read Michael's comments also.

> - Why do you recommend against the sed and mkdir macros?

Becasue RPM does know where is sed and mkdir -p now, you don't need to keep a style for years ago.

> - I did recommend upstream support DESTDIR or PREFIX in the Makefile, and
> they were open to adding it. There may even be a Makefile.fedora for our use
> case, but in any event it is not included in the current release. I will
> package it up in an update.

Ok, nice.
Comment 7 Ralf Corsepius 2013-09-06 00:32:51 EDT
> Or something in the Makefile strips the built files.
That's it. The Makefile explictly strips the binary.

Additionally, the spec file doesn't propagate RPM_OPT_FLAGS to the Makefile.

Further issues:

* Bogus BRs:
AFAIS, this package doesn't require the GHC-OpenGL bindings but only requires the C-OpenGL bindings.

Also, I my gut feeling is some other BRs are superflous (xdg-utils?), but I haven't checked.

* AFAIS, the explict Requires are all superflous and should all be removed.

* The sed-hacking of the Makefile should likely be moved into %build.
Comment 8 Ralf Corsepius 2013-09-06 00:36:03 EDT
Created attachment 794571 [details]
changes to spec to address issues from comment #7
Comment 9 Ralf Corsepius 2013-09-06 00:37:09 EDT
(In reply to Christopher Meng from comment #6)
> > - Why do you recommend against the sed and mkdir macros?
> 
> Becasue RPM does know where is sed and mkdir -p now, you don't need to keep
> a style for years ago.
?!? You seem to be very confused.
Comment 10 Ralf Corsepius 2013-09-06 01:06:20 EDT
Finally, building exposes these 2 pretty serious warnings:
...
src/e_checks.cc: In function 'check_result_e CHECK_Things(int)':
src/e_checks.cc:1494:60: warning: format '%u' expects argument of type 'unsigned int', but argument 3 has type 'std::map<int, int>::size_type {aka long unsigned int}' [-Wformat=]
    sprintf(check_message, "%u unknown things", types.size());
                                                            ^
...
src/m_files.cc: In member function 'void RecentFiles_c::insert(const char*, const char*)':
src/m_files.cc:215:42: warning: array subscript is above array bounds [-Warray-bounds]
    filenames[index] = filenames[index + 1];
                                          ^
...

Whether the 1st one is serious is arguable, but the 2nd one to me qualifies as  critical and MUSTFIX.
Comment 11 Jay Greguske 2013-09-06 08:26:28 EDT
Thanks for the feedback gang! I will have another build to propose over the weekend.
Comment 12 Jay Greguske 2013-09-08 08:52:37 EDT
I built a -3 version of the package if anyone wants to see the progress so far. I relayed the concerns in comment 10 to upstream today. That's the last issue I'm aware of that is not addressed in -3.

http://jgreguske.fedorapeople.org/eureka/eureka-1.00-3.fc19.src.rpm
http://jgreguske.fedorapeople.org/eureka/eureka.spec

Thanks for the patch, Ralf.
Comment 13 Christopher Meng 2013-09-08 10:43:28 EDT
Sorry, I have to reset the assignee because I will be very busy in the next week.

Sorry again...
Comment 14 Christopher Meng 2013-11-08 11:21:18 EST
Take again.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in
     /home/rpmaker/Desktop/eureka/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 51200 bytes in 5 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: eureka-1.00-3.fc21.i686.rpm
          eureka-1.00-3.fc21.src.rpm
eureka.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
eureka.i686: E: incorrect-fsf-address /usr/share/doc/eureka/GPL.txt
eureka.i686: W: no-manual-page-for-binary eureka
eureka.src: W: spelling-error %description -l en_US multi -> mulch, mufti
2 packages and 0 specfiles checked; 1 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint eureka
eureka.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
eureka.i686: E: incorrect-fsf-address /usr/share/doc/eureka/GPL.txt
eureka.i686: W: no-manual-page-for-binary eureka
1 packages and 0 specfiles checked; 1 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
eureka (rpmlib, GLIBC filtered):
    libGL.so.1
    libX11.so.6
    libXext.so.6
    libXft.so.2
    libXinerama.so.1
    libc.so.6
    libfltk.so.1.3
    libfltk_gl.so.1.3
    libfltk_images.so.1.3
    libfontconfig.so.1
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libjpeg.so.62
    libm.so.6
    libpng16.so.16
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    libz.so.1
    rtld(GNU_HASH)



Provides
--------
eureka:
    eureka
    eureka(x86-32)



Source checksums
----------------
http://downloads.sourceforge.net/project/eureka-editor/Eureka/1.00/eureka-1.00-source.tar.gz :
  CHECKSUM(SHA256) this package     : 314b18c911f0699788b0189081fd5aace524aca6b3687c2a96dda2e223a40ad2
  CHECKSUM(SHA256) upstream package : 314b18c911f0699788b0189081fd5aace524aca6b3687c2a96dda2e223a40ad2


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -rvn eureka-1.00-3.fc19.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

----------------
PACKAGE APPROVED.

Please notify upstream about:

eureka.i686: E: incorrect-fsf-address /usr/share/doc/eureka/GPL.txt
Comment 15 Jay Greguske 2013-11-21 10:34:10 EST
Thanks!
Comment 16 Jay Greguske 2013-12-25 10:55:07 EST
New Package SCM Request
=======================
Package Name: eureka
Short Description: A cross-platform map editor for the classic DOOM games
Owners: jgreguske
Branches: f19 f20 el6
InitialCC:
Comment 17 Jens Petersen 2013-12-26 22:36:40 EST
Git done (by process-git-requests).
Comment 18 Fedora Update System 2014-02-12 21:02:12 EST
eureka-1.00-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/eureka-1.00-3.fc19
Comment 19 Fedora Update System 2014-02-12 21:03:57 EST
eureka-1.00-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/eureka-1.00-3.fc20
Comment 20 Fedora Update System 2014-02-14 03:04:40 EST
eureka-1.00-3.fc19 has been pushed to the Fedora 19 testing repository.
Comment 21 Fedora Update System 2014-02-24 07:27:50 EST
eureka-1.00-3.fc19 has been pushed to the Fedora 19 stable repository.
Comment 22 Fedora Update System 2014-02-24 07:28:15 EST
eureka-1.00-3.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.